jQuery(document).ready( function($) {
    $('#wpfresh4-tabs a.nav-tab').click(function(e){
        e.preventDefault();
        $(this).addClass("nav-tab-active");
        $(this).siblings().removeClass("nav-tab-active");
        var tab = $(this).attr("href");
        $(".tab-inner").not(tab).css("display", "none");
        $(tab).fadeIn();
    });
    jQuery('.wpfresh4-color-picker').wpColorPicker();

    jQuery('#wpfresh4-wizard2').formalize();

    /* 1.2. WP Image Selector */
    var _custom_media = true,
    _orig_send_attachment = wp.media.editor.send.attachment;

    jQuery(document).on('click', '.wpfresh4_img_upload', function(e) {
        e.preventDefault();
        var send_attachment_bkp = wp.media.editor.send.attachment;
        var button = jQuery(this);
        _custom_media = true;

        wp.media.editor.send.attachment = function(props, attachment){
            // console.log('a')
            if ( _custom_media ) {
            // console.log('b')

                // console.log(attachment)
                parent = button.closest('.file-upload-parent');
                parent.find('.file-upload-url').val(attachment.url)
                jQuery('.file-upload-url').trigger('change');
                parent.find('.file-upload-img').attr('src', attachment.url)
                parent.find('.file-upload-img').show();
            } else {
                return _orig_send_attachment.apply( this, [props, attachment] );
            };
        }

        wp.media.editor.open(button);
        return false;
    });

    jQuery(document).on('click', '.wpfresh4_img_clear', function(e) {
        e.preventDefault();
        var button = jQuery(this);
        parent = button.closest('.file-upload-parent');
        parent.find('.file-upload-url').val('')
        jQuery('.file-upload-url').trigger('change');
        parent.find('.file-upload-img').attr('src', '')
        parent.find('.file-upload-img').hide();
    });

    jQuery(document).on('click', '#wpfresh4-expand-all', function(e) {
        jQuery('#wpfresh4-wizard2 .form-section').show();
    });

    
    /* Custom Stuff */

    // 1. Content
    jQuery( 'input.wpfresh4_cc_create_cats').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_cc_catnames_row' ).show();
        else
            jQuery( '.wpfresh4_cc_catnames_row' ).hide();
    });

    jQuery( 'input.wpfresh4_cc_create_tags').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_cc_tagnames_row' ).show();
        else
            jQuery( '.wpfresh4_cc_tagnames_row' ).hide();
    });

    jQuery( 'input.wpfresh4_cc_create_pages').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_cc_pagenames_row' ).show();
        else
            jQuery( '.wpfresh4_cc_pagenames_row' ).hide();
    });

    jQuery( 'input.wpfresh4_cc_create_posts').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_cc_postnames_row' ).show();
        else
            jQuery( '.wpfresh4_cc_postnames_row' ).hide();
    });

    jQuery( 'input.wpfresh4_cu_underc_enabled').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_cu_underc_text_row' ).show();
        else
            jQuery( '.wpfresh4_cu_underc_text_row' ).hide();
    });

    jQuery( 'input.wpfresh4_cg_cookiew_enabled').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_cg_cookiew_text_row' ).show();
        else
            jQuery( '.wpfresh4_cg_cookiew_text_row' ).hide();
    });

    jQuery( 'input.wpfresh4_ci_optimize').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_ci_optimization_row' ).show();
        else
            jQuery( '.wpfresh4_ci_optimization_row' ).hide();
    });
    
    jQuery( 'input.wpfresh4_ci_watermark').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_ci_watermark_url_row' ).show();
        else
            jQuery( '.wpfresh4_ci_watermark_url_row' ).hide();
    });

    jQuery( 'input[name="wpfresh4_cg_createpage[amazon]"]').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_cg_amazoncountry_row' ).show();
        else
            jQuery( '.wpfresh4_cg_amazoncountry_row' ).hide();
    });

    jQuery( 'input.wpfresh4_cf_enable_fonts').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_cf_fonts_row' ).show();
        else
            jQuery( '.wpfresh4_cf_fonts_row' ).hide();
    });

    // 3. Security
    jQuery( 'input.wpfresh4_s_limit_logins').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_s_logins_num_row' ).show();
        else
            jQuery( '.wpfresh4_s_logins_num_row' ).hide();
    });

    jQuery( 'input.wpfresh4_s_ch_login_url').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_s_login_url_row' ).show();
        else
            jQuery( '.wpfresh4_s_login_url_row' ).hide();
    });

    jQuery( 'input.wpfresh4_s_hide_wp').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_s_hidewp_row' ).show();
        else
            jQuery( '.wpfresh4_s_hidewp_row' ).hide();
    });
    
    $('#wpfresh4_backup_start_backup').click(function(e){
        e.preventDefault(), jQuery.ajax({
            type: "GET",
            dataType: "json",
            url: ajaxurl,
            data: {
                action: "wpfresh4_db_backup_now"
            },
            beforeSend: function() {
                jQuery("#wpfresh4_backup_start_backup").after('<span id="wpfresh4_loading-message"> Loading...</span>')
            },
            success: function(e) {
                console.log(e)
                jQuery("#wpfresh4_db_backup_download_file").show(), jQuery('label[for="wpfresh4_db_backup_download_file"]').show(), jQuery("#wpfresh4_backup_download_file").attr("href", e.FullDownloadPath)
            },
            error: function() {},
            complete: function() {
                jQuery("#wpfresh4_loading-message").remove()
            }
        })
    });

    jQuery( 'input.wpfresh4_s_limit_logins').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_s_logins_num_row' ).show();
        else
            jQuery( '.wpfresh4_s_logins_num_row' ).hide();
    });

    // 4. SEO

    jQuery( 'input.wpfresh4_s_robotstxt').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_s_robotstxt_txt_row' ).show();
        else
            jQuery( '.wpfresh4_s_robotstxt_txt_row' ).hide();
    });

    jQuery( 'input.wpfresh4_sl_enable_business').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_sl_business_row' ).show();
        else
            jQuery( '.wpfresh4_sl_business_row' ).hide();
    });

    jQuery( 'input.wpfresh4_sl_enable_rating').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_sl_rating_row' ).show();
        else
            jQuery( '.wpfresh4_sl_rating_row' ).hide();
    });

    // 5. Branding
    jQuery( 'input.wpfresh4_bl_custom_enabled').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_bl_login_settings_row' ).show();
        else
            jQuery( '.wpfresh4_bl_login_settings_row' ).hide();
    });

    // 6. Social
    jQuery( 'input.wpfresh4_ss_show').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_ss_row' ).show();
        else
            jQuery( '.wpfresh4_ss_row' ).hide();
    });

    jQuery( 'input.wpfresh4_sm_twitter').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_sm_twitter_row' ).show();
        else
            jQuery( '.wpfresh4_sm_twitter_row' ).hide();
    });

    jQuery( 'input.wpfresh4_sm_googleplus').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_sm_googleplus_row' ).show();
        else
            jQuery( '.wpfresh4_sm_googleplus_row' ).hide();
    });

    jQuery( 'input.wpfresh4_sas_facebook').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_sas_facebook_row' ).show();
        else
            jQuery( '.wpfresh4_sas_facebook_row' ).hide();
    });

    jQuery( 'input.wpfresh4_sas_twitter').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_sas_twitter_row' ).show();
        else
            jQuery( '.wpfresh4_sas_twitter_row' ).hide();
    });
    // 7. Others

    jQuery( 'input.wpfresh4_oo_minimize_js').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfres_oo_exclude_js_row' ).show();
        else
            jQuery( '.wpfres_oo_exclude_js_row' ).hide();
    });

    jQuery( 'input.wpfresh4_oo_minimize_css').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfres_oo_exclude_css_row' ).show();
        else
            jQuery( '.wpfres_oo_exclude_css_row' ).hide();
    });

    jQuery( 'input.wpfresh4_ov_scrolltop').change( function( e ) {
        e.preventDefault();
        var $this = jQuery(this)
        var checked = $this.is( ':checked' );
        if( checked )
            jQuery( '.wpfresh4_ov_scrolltop_txt_row' ).show();
        else
            jQuery( '.wpfresh4_ov_scrolltop_txt_row' ).hide();
    });
    
    jQuery( '#wpfresh4-show-database').click( function( e ) {
        e.preventDefault();
        jQuery('#wpfresh4-database-tables').toggle();
    });

    jQuery("#wload-recommended-plugins").click(function(e){
        e.preventDefault();
        jQuery('#wpfresh4_own_plugins').val( jQuery('#wrecommended-plugins-txt').html());
    });

    /* Instareset */

    jQuery( 'a#wpfs4-more-instareset').click( function( e ) {
        e.preventDefault();
        jQuery('#advanced_instareset').toggle();
    });
});